poj1384——dp,完全背包

POJ 1384  dp,完全背包

Piggy-Bank

Time Limit: 1000MS   Memory Limit: 10000K
Total Submissions: 8404   Accepted: 4082

Description

Before ACM can do anything, a budget must be prepared and the necessary financial support obtained. The main income for this action comes from Irreversibly Bound Money (IBM). The idea behind is simple. Whenever some ACM member has any small money, he takes all the coins and throws them into a piggy-bank. You know that this process is irreversible, the coins cannot be removed without breaking the pig. After a sufficiently long time, there should be enough cash in the piggy-bank to pay everything that needs to be paid.

But there is a big problem with piggy-banks. It is not possible to determine how much money is inside. So we might break the pig into pieces only to find out that there is not enough money. Clearly, we want to avoid this unpleasant situation. The only possibility is to weigh the piggy-bank and try to guess how many coins are inside. Assume that we are able to determine the weight of the pig exactly and that we know the weights of all coins of a given currency. Then there is some minimum amount of money in the piggy-bank that we can guarantee. Your task is to find out this worst case and determine the minimum amount of cash inside the piggy-bank. We need your help. No more prematurely broken pigs!

Input

The input consists of T test cases. The number of them (T) is given on the first line of the input file. Each test case begins with a line containing two integers E and F. They indicate the weight of an empty pig and of the pig filled with coins. Both weights are given in grams. No pig will weigh more than 10 kg, that means 1 <= E <= F <= 10000. On the second line of each test case, there is an integer number N (1 <= N <= 500) that gives the number of various coins used in the given currency. Following this are exactly N lines, each specifying one coin type. These lines contain two integers each, Pand W (1 <= P <= 50000, 1 <= W <=10000). P is the value of the coin in monetary units, W is it‘s weight in grams.

Output

Print exactly one line of output for each test case. The line must contain the sentence "The minimum amount of money in the piggy-bank is X." where X is the minimum amount of money that can be achieved using coins with the given total weight. If the weight cannot be reached exactly, print a line "This is impossible.".

Sample Input

3
10 110
2
1 1
30 50
10 110
2
1 1
50 30
1 6
2
10 3
20 4

Sample Output

The minimum amount of money in the piggy-bank is 60.
The minimum amount of money in the piggy-bank is 100.
This is impossible.

题意:用一堆给定面值的硬币a1,a2,...,aN,(ai和aj的面值可以相同),组合成恰好质量为W的最小总面值思路:dp,设选择范围为前i个硬币组成质量恰好为j的最小面值为dp(i,j)=max(dp(i-1,j),dp(i-1,j-w[i])+p[i]),(j>=w[i])     边界:dp(i,j)=dp(i-1,j),dp(i)(0)=0(总质量为0,总面值肯定为0),初始化dp={INF},INF即总面值无限大,即没有合适的匹配方案;小技巧:观察边界可令j直接从w[i]——>W,而不是从0——>W;利用滚动数组可直接将空间将为一维

C++代码:

//poj1384  dp
#include<iostream>
#include<cstdio>
#include<cstring>
#include<algorithm>
#include<ctype.h>

using namespace std;

const int maxn=510;
const int INF=1000100;
int T;
int E,F;
int N;
int p[maxn],w[maxn];
int dp[INF];

int main()
{
    cin>>T;
    while(T--){
        cin>>E>>F>>N;
        for(int i=1;i<=N;i++){
            cin>>p[i]>>w[i];
        }
        for(int i=0;i<=F-E;i++) dp[i]=INF;
        dp[0]=0;
        for(int i=1;i<=N;i++){
            for(int j=w[i];j<=F-E;j++){
                    dp[j]=min(dp[j-w[i]]+p[i],dp[j]);
            }
        }
        if(dp[F-E]!=INF) cout<<"The minimum amount of money in the piggy-bank is "<<dp[F-E]<<"."<<endl;
        else cout<<"This is impossible."<<endl;
    }
    return 0;
}

dp_完全背包

Java代码:

//594ms
import java.util.*;
import java.io.*;

public class Main {
    static final int maxn=510;
    static final int INF=1000100;
    public static int min(int a,int b){
        return a<b?a:b;
    }
    public static void main(String[] args){
        Scanner in=new Scanner(System.in);
        int T=in.nextInt();
        while(T--!=0){
            int E=in.nextInt();
            int F=in.nextInt();
            int N=in.nextInt();
            int p[]=new int[N+1],w[]=new int[N+1];
            for(int i=1;i<=N;i++){
                p[i]=in.nextInt();
                w[i]=in.nextInt();
            }
            int dp[]=new int[F-E+1];
            for(int i=0;i<=F-E;i++) dp[i]=INF;
            dp[0]=0;
            for(int i=1;i<=N;i++){
                for(int j=w[i];j<=F-E;j++){
                    dp[j]=min(dp[j-w[i]]+p[i],dp[j]);
                }
            }
            if(dp[F-E]!=INF) System.out.println("The minimum amount of money in the piggy-bank is "+dp[F-E]+".");
            else System.out.println("This is impossible.");
        }
    }
}

dp——java

				
时间: 2024-08-10 17:17:56

poj1384——dp,完全背包的相关文章

USACO Money Systems Dp 01背包

一道经典的Dp..01背包 定义dp[i] 为需要构造的数字为i 的所有方法数 一开始的时候是这么想的 for(i = 1; i <= N; ++i){ for(j = 1; j <= V; ++j){ if(i - a[j] > 0){ dp[i] += dp[i - a[j]]; } } } 状态存在冗余, 输出的时候答案肯定不对 但只需要改一下两个for循环的顺序即可. Source Code: /* ID: wushuai2 PROG: money LANG: C++ */ //

hdu4003 树形dp+分组背包

http://acm.hdu.edu.cn/showproblem.php?pid=4003 Problem Description Humans have discovered a kind of new metal mineral on Mars which are distributed in point‐like with paths connecting each of them which formed a tree. Now Humans launches k robots on

hdu 1561The more, The Better(树形dp&amp;01背包)

The more, The Better Time Limit: 6000/2000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 4949    Accepted Submission(s): 2918 Problem Description ACboy很喜欢玩一种战略游戏,在一个地图上,有N座城堡,每座城堡都有一定的宝物,在每次游戏中ACboy允许攻克M个城堡并获得里面的宝

poj1014 dp 多重背包

1 //Accepted 624 KB 16 ms 2 //dp 背包 多重背包 3 #include <cstdio> 4 #include <cstring> 5 #include <iostream> 6 using namespace std; 7 const int imax_n = 120005; 8 int f[imax_n]; 9 int amount[7]; 10 int v; 11 int n=6; 12 int max(int a,int b) 1

poj 3345 Bribing FIPA 【树形dp + 01背包】

Bribing FIPA Time Limit: 2000MS   Memory Limit: 65536K Total Submissions: 4274   Accepted: 1337 Description There is going to be a voting at FIPA (Fédération Internationale de Programmation Association) to determine the host of the next IPWC (Interna

HDU ACM 4044 GeoDefense -&gt;树形DP+分组背包

题意:地图是一个编号为1-n的节点的树,节点1是敌方基地,其他叶节点是我方基地.敌人基地会出来敌人,为了防止敌人攻进我方基地,我们可以选择造塔.每个节点只能造一个塔,节点i有ki种塔供选择,价值和攻击力为price_i, power_i,攻击力power_i是让敌人经过这个节点时让敌人的HP减少power_i点.因此从敌人基地到我方任意一个基地的路径,这条路径上所有塔的攻击力之和,就是这个基地的抵抗力. 敌人攻击路径不确定,为了保护我方所有基地,需要确定所有基地中抵抗力最低的一个.我方只有数量为

hdu 5389 dp类似背包

http://acm.hdu.edu.cn/showproblem.php?pid=5389 Problem Description Zero Escape, is a visual novel adventure video game directed by Kotaro Uchikoshi (you may hear about ever17?) and developed by Chunsoft. Stilwell is enjoying the first chapter of this

poj 1837 Balance (dp,01背包)

链接:poj 1837 题意:有一个天平,天平左右两边各有若干个钩子,总共有C个钩子,有G个钩码, 求将钩码挂到钩子上使天平平衡的方法的总数.其中可以把天枰看做一个以x轴0点作为平衡点的横轴 分析:力臂=重量 *臂长 = g[i]*c[j] 当平衡度k=0时,说明天枰达到平衡,k>0,说明天枰倾向右边(x轴右半轴),k<0则左倾 因此可以定义一个 状态数组dp[i][k],意为在挂满前i个钩码时,平衡度为k的挂法的数量. 由于距离c[i]的范围是-15~15,钩码重量的范围是1~25,钩码数量

ZOJ 3450 Doraemon&#39;s Railgun (DP&#183;分组背包)

题意  多啦A梦有一个超电磁炮  然后要打死n堆敌人  在同一条射线上的敌人只有先打死前面的一堆才能打后面的一堆  给你打死某堆敌人需要的时间和这堆敌人的人数   问你在T0时间内最多打死多少个敌人 分组背包问题  先要把同一条射线上的敌人放到一个分组里  后面的敌人的时间和人数都要加上前面所有的  因为只有前面的都打完了才能打后面的  然后每组最多只能选择一个   判断共线用向量处理   然后去背包就行了 注意给你的样例可能出现t=0的情况   在分组时需要处理一下    被这里卡了好久 #i